//--------------------------------
// Routines gestion des presets
// pour le programme OneBitSynth
//--------------------------------

//----------------------------------
// Procedure chargement d'un preset
// lecture du preset depuis l'EEPROM
// rechargement des variables
// Si mess=1 on affiche "select"
//----------------------------------
void LoadPreset(byte numpreset,byte mess) {
int i;
	noteon=0;
	switch(mess) {
		case 1:
			lcd.setCursor(8,0);
			lcd.print("Loading...");
			break;
		default:
			break;
	}
    myaddress = (numpreset-1)*PRESETSIZE;			// Compute address
	wavenum=EEPROM.read(myaddress++);			// READ wavenum (16 bits)
	myByte1=EEPROM.read(myaddress++);				// READ pitch
    myByte2=EEPROM.read(myaddress++);                           
	pitch=word(myByte1,myByte2);                          
	usemidi=EEPROM.read(myaddress++);				// READ midimode                           
	lfowavenum=EEPROM.read(myaddress++);		// READ LFO wave                  
	myByte1=EEPROM.read(myaddress++);               // READ LFO Freq (16 bits)            
    myByte2=EEPROM.read(myaddress++);                           
	lfofreq=word(myByte1,myByte2);                              
	myByte1=EEPROM.read(myaddress++);              	// READ LFO Depth (16 bits)             
    myByte2=EEPROM.read(myaddress++);                           
	lfodepth=word(myByte1,myByte2);                             
	envfreq=EEPROM.read(myaddress++);				// READ envelope frequency
	envwidth=EEPROM.read(myaddress++);              // READ envelope width
	RefreshRateLfo=EEPROM.read(myaddress++);        // READ refresh rate of the LFO
	RefreshRateEnv=EEPROM.read(myaddress++);        // READ refresh rate of the Envelope
	myByte1=EEPROM.read(myaddress++);				// READ user waveform (16 bits)
    myByte2=EEPROM.read(myaddress++);
	UserWaveform=word(myByte1,myByte2);
	cv1dest=EEPROM.read(myaddress++);				// READ CV1 destination
	cv2dest=EEPROM.read(myaddress++);               // READ CV2 destination
	cv3dest=EEPROM.read(myaddress++);               // READ CV3 destination
	if (wavenum!=8)
		waveform = waveforms[wavenum];
	else
		waveform = UserWaveform;
	delay(200);
	switch(mess) {
		case 1:
			lcd.setCursor(8,0);
			lcd.print("Select      ");
			break;
		default:
			break;
	}	
	if (!usemidi)
		noteon=1;
	else
		noteon=0;
}

//----------------------------------
// Procedure sauvegarde d'un preset
// lecture du preset depuis l'EEPROM
// rechargement des variables
// Si mess=1 on affiche "select"
//----------------------------------
void SavePreset(byte numpreset,byte mess) {
int i;
	switch(mess) {
		case 1:
			lcd.setCursor(8,0);
			lcd.print("Saving...");
			break;
		case 2:
			lcd.setCursor(0,1);
			lcd.print(F("Preset : "));
			digitsLcd(numpreset,2);
			break;
		default:
			break;
	}
    myaddress = (numpreset-1)*PRESETSIZE;					// Compute address
	EEPROM.write(myaddress++, wavenum);						// WR wavenum
	EEPROM.write(myaddress++, highByte(pitch));				// WR pitch
	EEPROM.write(myaddress++, lowByte(pitch));
	EEPROM.write(myaddress++, usemidi);						// WR midimode
	EEPROM.write(myaddress++, lfowavenum);					// WR LFO wave
	EEPROM.write(myaddress++, highByte(lfofreq));			// WR LFO Freq (16 bits)
	EEPROM.write(myaddress++, lowByte(lfofreq));
	EEPROM.write(myaddress++, highByte(lfodepth));			// WR LFO Depth (16 bits)
	EEPROM.write(myaddress++, lowByte(lfodepth));
	EEPROM.write(myaddress++, envfreq);						// WR envelope frequency
	EEPROM.write(myaddress++, envwidth);					// WR envelope width
	EEPROM.write(myaddress++, RefreshRateLfo);				// WR refresh rate of the LFO
	EEPROM.write(myaddress++, RefreshRateEnv);				// WR refresh rate of the Envelope
	EEPROM.write(myaddress++, highByte(UserWaveform));		// WR user waveform (16 bits)
	EEPROM.write(myaddress++, lowByte(UserWaveform));
	EEPROM.write(myaddress++, cv1dest);						// WR CV1 destination
	EEPROM.write(myaddress++, cv2dest);						// WR CV2 destination
	EEPROM.write(myaddress++, cv3dest);						// WR CV3 destination
	delay(100);
	switch(mess) {
		case 1:
			lcd.setCursor(8,0);
			lcd.print("Select      ");
			break;
		default:
			break;
	}
}

//----------------------------------------------------------------
// Procedure d'initialisation de l'EEPROM locale
// Utilise les parametres par defaut pour initialiser les presets
// Chaque preset a la taille PRESETSIZE
// Le nombre preset formate est de MAXPRESETS
//----------------------------------------------------------------
void InitialisationEEPROM(void) {
byte i;
	lcd.clear();
	lcd.print("INIT EEPROM");
	for (i=1; i<=MAXPRESETS; i++) {
		SavePreset(i,2);
		delay(100);
	}
	lcd.clear();
	lcd.print("EEPROM INITIALISEE !");
	delay(2000);
	lcd.clear();
}

