//-----------------------------------------
// procedures pour gerer les affichages LCD
// pour le programme OneBitSynth
//-----------------------------------------

//-------------------------------
	// Rafraichissement parametre LCD
// si MAJ externe CV ou midi
//-------------------------------
void RaffLcd() {
	// Pour ralentir le rafraichissement
	// Ne fait quelques chose que tous les 'DELAYRAFF' execution
	if (RaffCount++ >DELAYRAFF) {
		RaffCount=0;
	}

	switch(nummenu) {
		// Si menu Oscillator
		// case 0:
			// break;
		// Si menu LFO
		case 1:
			if (RaffParamLcd[1]) {
				RaffLcdLfoWave();
				RaffParamLcd[1]=0;
				return;
			}
			if (RaffParamLcd[2]) {
				RaffLcdLfoFreq();
				RaffParamLcd[2]=0;
				return;
			}
			if (RaffParamLcd[3]) {
				RaffLcdLfoDepth();
				RaffParamLcd[3]=0;
				return;
			}
			break;
		// Menu edition enveloppe
		// case 2:
			// EnvelopeMenu();
			// break;
		// Menu edition vitesse refresh LFO et Enveloppe
		// case 3:
			// RefreshRateMenu();
			// break;
		// Menu edition forme onde personnalisee
		// case 4:
			// break;
		// Menu PRESET
		// case 10:
			// break;
			
	}	
}

//--------------------------------------------------------
// Affiche une donne numerique avec des 0 non significatif
// nbdigits = longueur totale du nombre  entre 1 et 5 chiffres
//--------------------------------------------------------
void digitsLcd(int valeur, byte nbdigits) {
  if (nbdigits==5 && valeur <10000)
      lcd.print(F("0"));
  if (nbdigits>=4 && valeur <1000)
      lcd.print(F("0"));
  if (nbdigits>=3 && valeur <100)
      lcd.print(F("0"));
  if (valeur<10)
      lcd.print(F("0"));
  lcd.print(valeur,DEC);
}

//---------------------------------------------------------------------
// Affiche une donne numerique avec des 0 non significatif
// nbdigits = longueur totale du nombre  entre 1 et 5 chiffres
// le tout à la position x,y
//---------------------------------------------------------------------
void digitsLcdPos(int valeur, byte x, byte y, byte nbdigits) {
	lcd.setCursor(x,y);
	digitsLcd(valeur,nbdigits);
}

//--------------------------------------------------------
// Affiche "On" si valeur >0 sinon Off
// le tout a la position x,y
//--------------------------------------------------------
void OnOffLcd(byte valeur, byte x, byte y) {
  lcd.setCursor(x,y);      
  if (valeur)
      lcd.print(F("On "));
  else
      lcd.print(F("Off"));
}

//---------------------------------------------------
// Affiche une chaine passee en parametre
// avec lecture du midi entre chaque caractere
// Identique au fonctionnement de affChaineLcdPROGMEM
// mais utilise la RAM
//---------------------------------------------------
void affChaineLcd(char *mychaine) {
int i;
char *p;
  p=mychaine;
  for (i=0;i<strlen(mychaine);i++,p++) {
     lcd.printByte(*p);
  }
}

//----------------------------------------
// Affiche un octet en binaire
// Avec un B devant
//----------------------------------------
void aff_binary(byte oct) {
byte i;
    lcd.print(F("B"));
    for (i=8; i>0; i--) {
        if (bitRead(oct,i-1))
            lcd.print(F("1"));
        else
            lcd.print(F("0"));
    }
}

//-----------------------------
// Affiche un entier en binaire
// du bit 15 vers le bit 0
//-----------------------------
void aff_binary_integer(uint16_t monentier) {
byte i;
    for (i=16; i>0; i--) {
        if (bitRead(monentier,i-1))
            lcd.print(F("1"));
        else
            lcd.print(F("0"));
    }
}

//---------------------------------------------------
// Affiche des chaines statiques sur le LCD
// on aurait pu utiliser lcd.print simplement
// mais cette procedure permet de lire le MIDI
// entre chaque caractere affiche, cela permet
// pendant un affichage important de reduire
// la latence.
// Les chaines sont en PROGMEM pour liberer de la RAM
//---------------------------------------------------
void affOndesLcdPROGMEM(byte item) {

byte pos;
  memset(BuffAff,0,sizeof(BuffAff));
  // recopie item de la flash vers une chaine en RAM
  strcpy_P(BuffAff, (char*)pgm_read_word(&(WaveNameLfo[item])));
  for (pos=0;pos<strlen(BuffAff);pos++) {
       lcd.print(BuffAff[pos]);
  }
}
